Attribute VB_Name = "MiscProcs"
'----------------------------------------------------------------------
' MiscProcs - Murphy McCauley 08/12/99
'----------------------------------------------------------------------
' These are just a couple of functions I took out of MurfLib 4 and
' stripped down.
' ForceForegroundWindow() pushes a window to the front -- even in
' Win98/NT4+ (which generally prohibit this behavior).
'----------------------------------------------------------------------
' o|~ Men are from Mars, men are from Mars, men are from Mars...
'----------------------------------------------------------------------

Option Explicit

'Stuff for ForceForegroundWindow()...
Private Const SPI_GETFOREGROUNDLOCKTIMEOUT = &H2000&
Private Const SPI_SETFOREGROUNDLOCKTIMEOUT = &H2001&
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
 Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long

'Stuff for the mouse functions...
Type APoint
    X As Long
    y As Long
End Type
Declare Function GetCursorPos Lib "user32" (Point As APoint) As Long
Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal y As Long) As Long
Declare Function GetAsyncKeyState Lib "user32" (ByVal VirtualKey As Long) As Long
'my little variable
Public Mppath
'for changing the res
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

Public Const KEY_TOGGLED As Integer = &H1

Public Const KEY_PRESSED As Integer = &H1000

Public Const VK_LSHIFT = &HA0
Public Const VK_RSHIFT = &HA1
Public Const VK_LCONTROL = &HA2
Public Const VK_RCONTROL = &HA3
Public Const VK_LMENU = &HA4
Public Const VK_RMENU = &HA5
Public Const KEYEVENTF_KEYUP = &H2
Declare Function SetKeyboardState Lib "user32.dll" (lpKeyState As Byte) As Long
Public Declare Function MoveWindow Lib "user32" ( _
           ByVal hwnd As Long, _
           ByVal X As Long, _
           ByVal y As Long, _
           ByVal nWidth As Long, _
           ByVal nHeight As Long, _
           ByVal bRepaint As Long _
) As Long


'bitblit stuff
Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Const SRCPAINT = &HEE0086         ' (DWORD) dest = source OR dest
Public Const SRCAND = &H8800C6   ' (DWORD) dest = source AND dest
Public Const SRCINVERT = &H660046        ' (DWORD) dest = source XOR dest
Public Const SRCERASE = &H440328         ' (DWORD) dest = source AND (NOT dest )
Public Const NOTSRCCOPY = &H330008       ' (DWORD) dest = (NOT source)
Public Const NOTSRCERASE = &H1100A6      ' (DWORD) dest = (NOT src) AND (NOT dest)
Public Const MERGECOPY = &HC000CA        ' (DWORD) dest = (source AND pattern)
Public Const MERGEPAINT = &HBB0226       ' (DWORD) dest = (NOT source) OR dest
Public Const PATCOPY = &HF00021  ' (DWORD) dest = pattern
Public Const PATPAINT = &HFB0A09         ' (DWORD) dest = DPSnoo
Public Const PATINVERT = &H5A0049        ' (DWORD) dest = pattern XOR dest
Public Const DSTINVERT = &H550009        ' (DWORD) dest = (NOT dest)
Public Const BLACKNESS = &H42&   ' (DWORD) dest = BLACK
Public Const WHITENESS = &HFF0062        ' (DWORD) dest = WHITE
 
 Public Declare Function TransparentBlt Lib "msimg32" (ByVal hdcDest As Long, _
ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest _
As Long, ByVal nHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc _
As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal _
nHeightSrc As Long, ByVal crTransparent As Long) As Long

Public CapVal(255) As Long 'the cap's value
Public CapSp(255) As Long


Function ForceForegroundWindow(TheHWnd As Long)
    If TheHWnd <> GetForegroundWindow Then
        Dim OriginalTimeout As Long
        Dim TempL As Long, uP As Long
        Dim Success As Long
        Success = SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, uP, OriginalTimeout, 0)
        If Success <> 0 Then
            Call SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, uP, ByVal 0, 0)
        End If
        
        Call SetForegroundWindow(TheHWnd)
        If Success <> 0 Then
            Call SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, uP, ByVal OriginalTimeout, 0)
        End If
    End If
End Function

Function MousePointerPosition() As APoint
    'Not exactly what's in MurfLib4... I stripped it down.
    Dim CurrentPos As APoint
    Call GetCursorPos(CurrentPos)
    MousePointerPosition = CurrentPos
End Function

Function MouseButtonIsDown() As Boolean
    'Not exactly what's in MurfLib4... I stripped it down.
    
    Dim IsDown As Boolean
            
    If (GetAsyncKeyState(1) = -32767) Or ((GetAsyncKeyState(1) And 2 ^ 15) <> 0) Then
        IsDown = True
    ElseIf (GetAsyncKeyState(2) = -32767) Or ((GetAsyncKeyState(2) And 2 ^ 15) <> 0) Then
        IsDown = True
    Else
        IsDown = False
    End If
    
    MouseButtonIsDown = IsDown
End Function

